<?php
if (!defined('XOOPS_ROOT_PATH')) exit();

define ("BBSB_FRAME_PERFORM_SUCCESS",	1);
define ("BBSB_FRAME_VIEW_SUCCESS",		2);
define ("BBSB_FRAME_VIEW_ERROR",		3);
define ("BBSB_FRAME_VIEW_INDEX",		4);
define ("BBSB_FRAME_VIEW_INPUT",		5);
//define ("BBSB_FRAME_VIEW_PREVIEW",		6);
define ("BBSB_FRAME_VIEW_CANCEL",		7);

// ե졼
class BBSB_ActionFrame
{
	var $mActionName	= null;		// ̾
	var $mAction		= null;		// Υ󥹥
	var $mAdminFlag		= null;		// ԥե饰
	var $mCreateAction	= null;		// XCube ǥꥲ

	/**
	 * 󥹥ȥ饯
	 * @param $admin Ԥξtrue
	 * @return unknown_type
	 */
	function BBSB_ActionFrame($admin)
	{
		$this->mAdminFlag = $admin;		// ե饰
		$this->mCreateAction =& new XCube_Delegate();
		$this->mCreateAction->register('BBSB_ActionFrame.CreateAction');
		$this->mCreateAction->add(array(&$this, '_createAction'));
	}

	/**
	 * ̾򥻥å
	 * @param $name
	 * @return unknown_type
	 */
	function setActionName($name)
	{
		$this->mActionName = $name;
		$root =& XCube_Root::getSingleton();
		$root->mContext->setAttribute('actionName', $name);
		$root->mContext->mModule->setAttribute('actionName', $name);
	}

	/**
	 * 
	 * ɬפʥ饹ɤ
	 * @param $actionFrame
	 * @return unknown_type
	 */
	function _createAction(&$actionFrame)
	{
		if (is_object($this->mAction)) {
			return;
		}

		//
		// Create action object by mActionName
		//
		$className	= "BBSB_" . $actionFrame->mActionName . "Action";
		$fileName	= $actionFrame->mActionName . "Action";
		if ($actionFrame->mAdminFlag) {
			$fileName = XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/admin/actions/Admin${fileName}.class.php";
		}
		else {
			$fileName = XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/actions/${fileName}.class.php";
		}
		if (!file_exists($fileName)) {
			die();
		}

		require_once $fileName;

		if (class_exists($className)) {
			$actionFrame->mAction =& new $className($actionFrame->mAdminFlag);
		}
	}

	/**
	 * Ͽ¹
	 * @param $controller
	 * @return unknown_type
	 */
	function execute(&$controller)
	{
		if (!preg_match("/^\w+$/", $this->mActionName)) {
			die();
		}

		// _createAction Call
		$this->mCreateAction->call(new XCube_Ref($this));

		if (!(is_object($this->mAction) )) {
			die();
		}

		// 
		$this->mAction->prepare($controller, $controller->mRoot->mContext->mXoopsUser, $controller->mRoot->mContext->mModuleConfig);

		if (xoops_getenv("REQUEST_METHOD") == "POST") {
			$viewStatus = $this->mAction->execute($controller, $controller->mRoot->mContext->mXoopsUser);
		}
		else {
			$viewStatus = $this->mAction->getDefaultView($controller, $controller->mRoot->mContext->mXoopsUser);
		}

		switch($viewStatus) {
			case BBSB_FRAME_VIEW_SUCCESS:
				$this->mAction->executeViewSuccess($controller, $controller->mRoot->mContext->mXoopsUser, $controller->mRoot->mContext->mModule->getRenderTarget());
				break;

			case BBSB_FRAME_VIEW_ERROR:
				$this->mAction->executeViewError($controller, $controller->mRoot->mContext->mXoopsUser, $controller->mRoot->mContext->mModule->getRenderTarget());
				break;

			case BBSB_FRAME_VIEW_INDEX:
				$this->mAction->executeViewIndex($controller, $controller->mRoot->mContext->mXoopsUser, $controller->mRoot->mContext->mModule->getRenderTarget());
				break;

			case BBSB_FRAME_VIEW_INPUT:
				$this->mAction->executeViewInput($controller, $controller->mRoot->mContext->mXoopsUser, $controller->mRoot->mContext->mModule->getRenderTarget());
				break;

//			case BBSB_FRAME_VIEW_PREVIEW:
//				$this->mAction->executeViewPreview($controller, $controller->mRoot->mContext->mXoopsUser, $controller->mRoot->mContext->mModule->getRenderTarget());
//				break;
//
			case BBSB_FRAME_VIEW_CANCEL:
				$this->mAction->executeViewCancel($controller, $controller->mRoot->mContext->mXoopsUser, $controller->mRoot->mContext->mModule->getRenderTarget());
				break;
		}
	}
}
?>